CONST
  SCRX = 640;  SCRY = 480;

{ ⠭     ES:DI  0- ࠭  
  न⠬  AX (x)  BX (y).  CLD  CL = 3. }
procedure  VideoAddr; assembler;
        asm
        cld
        mov     cl,3
        shr     ax,cl
        mov     di,ax
        mov     ax,SCRX shr 3
        mul     bx
        add     di,ax
        mov     ax,0A000H
        mov     es,ax
        end; {VideoAddr}

{ ⠭ ॣ. ᪨  ah }
procedure  SetMask; assembler;
        asm
        mov     dx,3CEH
        mov     al,8
        out     dx,ax
        end;  {SetMask}

{ ⠭ ॣ. 梥  ah }
procedure  SetCol; assembler;
        asm
        mov     dx,3C4H
        mov     al,2
        out     dx,ax
        end; {SetCol}

{ ⠭ ॣ. ०   ah }
procedure  SetRegim; assembler;
        asm
        mov     dx,3CEH
        mov     al,5
        out     dx,ax
        end; {SetRegim}

{ ⥭ 窨 }
function  GetPix (x,y : word) : byte; assembler;
        asm
        mov     ax,x
        mov     bx,y
        call    VideoAddr
        mov     cx,x
        and     cx,7
        neg     cx
        add     cx,7            { CX - . ᤢ ࠢ }
        mov     dx,3CEH
        xor     bl,bl
        mov     ah,3
@1:     mov     al,4
        out     dx,al
        inc     dx
        mov     al,ah
        out     dx,al
        dec     dx
        mov     al,es:[di]
        shr     al,cl
        and     al,1
        xchg    cl,ah
        shl     al,cl
        xchg    cl,ah
        or      bl,al
        dec     ah
        jns     @1
        mov     al,bl
        end; {GetPix}

{ 뢮 窨  ࠭ 0 梥⮬ color }
procedure  PutPix (x,y : word; color : byte); assembler;
        asm
        mov     ax,x
        mov     bx,y
        call    VideoAddr
        mov     cl,byte ptr x
        and     cl,7
        mov     ah,80H
        shr     ah,cl
        call    SetMask
        mov     cx,15
        cmp     color,0
        jz      @1
        mov     cl,color        {CL - 梥  }
        dec     ch              {CH -   }
@1:     xor     al,al
        xchg    es:[di],al
        mov     ah,cl
        call    SetCol
        mov     al,ch
        stosb
        mov     ah,15
        call    SetCol
        mov     ah,0FFH
        call    SetMask
        end; {PutPix}
